// Copyright 2018 gf Author(https://github.com/gogf/gf). All Rights Reserved.
//
// This Source Code Form is subject to the terms of the MIT License.
// If a copy of the MIT was not distributed with this file,
// You can obtain one at https://github.com/gogf/gf.

package mutex_test

import (
    "github.com/gogf/gf/g/internal/mutex"
    "testing"
)

var (
    safeLock   = mutex.New(false)
    unsafeLock = mutex.New(true)
)

func Benchmark_Safe_LockUnlock(b *testing.B) {
    for i := 0; i < b.N; i++ {
        safeLock.Lock()
        safeLock.Unlock()
    }
}

func Benchmark_UnSafe_LockUnlock(b *testing.B) {
    for i := 0; i < b.N; i++ {
        unsafeLock.Lock()
        unsafeLock.Unlock()
    }
}
