package main

import (
	"github.com/gogf/gf/g"
	"github.com/gogf/gf/g/net/ghttp"
	"github.com/gogf/gf/g/util/gvalid"
)

func main() {
	type User struct {
		Uid   int    `gvalid:"uid@min:1"`
		Name  string `params:"username"  gvalid:"username @required|length:6,30"`
		Pass1 string `params:"password1" gvalid:"password1@required|password3"`
		Pass2 string `params:"password2" gvalid:"password2@required|password3|same:password1#||两次密码不一致，请重新输入"`
	}

	s := g.Server()
	s.BindHandler("/user", func(r *ghttp.Request) {
		user := new(User)
		r.GetToStruct(user)
		if err := gvalid.CheckStruct(user, nil); err != nil {
			r.Response.WriteJson(err.Maps())
		} else {
			r.Response.Write("ok")
		}
	})
	s.SetPort(8199)
	s.Run()
}
